/*---------------------------------------------------------------------------*
*    Program Name : Analog Clock                                             *
*    Reference Book :  Visual C++ 6 Bible    Richard C. Leinecker            *
*                                            Tom Archer                      *
*                                                                            *
*    Author : Gemi                                                           *
*    E-mail: gemi0305@msn.com                                                *
*----------------------------------------------------------------------------*/
#include <vcl.h>
#include <math.h>


#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
    	nCenterX = Form1->ClientWidth / 2;
	nCenterY = Form1->ClientHeight / 2;

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Timer1Timer(TObject *Sender)
{

                                              // Draw the circle

   Canvas->Pen->Color=clGray;
   Canvas->Pen->Width=3;
   Canvas->Pen->Style= psSolid;
   Form1->Canvas->Ellipse(6,6,Form1->ClientWidth-6,Form1->ClientHeight-6);


   int x,y;
   double Radians;
   for(int i=1; i<=12; i++){
                                             // Draw 12 hour_mark
       Radians = (double) i*6.28 / 12.0;

       if(i>=10)
         {
            x=nCenterX -8 + (int)((double)(nCenterX - 20)* sin(Radians));
            y=nCenterY -4 - (int)((double)(nCenterY - 20)*cos(Radians));
         }
        else
         {
            x=nCenterX -4 + (int)((double)(nCenterX - 20)* sin(Radians));
            y=nCenterY -4 - (int)((double)(nCenterY - 20)*cos(Radians));
         }
        Canvas->TextOutA(x,y,IntToStr(i));

       }
                                              // Draw the hour needle
   Radians = Now().FormatString("h").ToDouble() +
             Now().FormatString("n").ToDouble() /60.0+
             Now().FormatString("s").ToDouble() /3600.0 ;

   Radians *= 6.28/12.0;

   Canvas->Pen->Color=clBlue;
   Canvas->Pen->Width=3;
   Canvas->Pen->Style= psSolid;

   Canvas->MoveTo(nCenterX, nCenterY);
   Canvas->LineTo(
         nCenterX + (int)((double)(nCenterX / 3)*sin(Radians)),
         nCenterY - (int)((double)(nCenterX / 3)*cos(Radians)));

                                               // Draw the minute needle
   Radians = Now().FormatString("n").ToDouble() +
             Now().FormatString("s").ToDouble() /60.0;


   Radians *= 6.28/60.0;



   Canvas->Pen->Color=clRed;
   Canvas->Pen->Width=3;
   Canvas->Pen->Style= psSolid;

   Canvas->MoveTo(nCenterX, nCenterY);
   Canvas->LineTo(
         nCenterX + (int)((double)((nCenterX*2) / 3)*sin(Radians)),
         nCenterY - (int)((double)((nCenterX*2) / 3)*cos(Radians)));


                                               // Draw the second needle
   Radians = Now().FormatString("s").ToDouble();

   Radians *= 6.28/60.0;

   Canvas->Pen->Color=clGreen;
   Canvas->Pen->Width=1;
   Canvas->Pen->Style= psSolid;

   Canvas->MoveTo(nCenterX, nCenterY);
   Canvas->LineTo(
         nCenterX + (int)((double)((nCenterX*4) / 5)*sin(Radians)),
         nCenterY - (int)((double)((nCenterX*4) / 5)*cos(Radians)));



}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormResize(TObject *Sender)
{
    	nCenterX = Form1->ClientWidth / 2;
	nCenterY = Form1->ClientHeight / 2;
       /* Canvas->Pen->Color=clBlack;
        Canvas->Pen->Style=bsSolid;
        Canvas->Rectangle(0,0,Form1->ClientWidth,Form1->ClientHeight);*/
}
//---------------------------------------------------------------------------

